var after3rdLevelScreen = function (game) { };
after3rdLevelScreen.prototype = {

    preload: function () {
        
    },
    create: function () {
        //loaded file
        this.backGroundRoom = this.add.sprite(0, 0, "backgroundMainMenu");
        this.middleMsgBox = addActor(this, 185, 196, "messbox", 700, 384, 101, false, {}, {});
        this.middleMsgTxt = this.add.text(270, 270, "Please give us your feedback and\nrate and comment the app", { font: "bold 32px Arial", fill: "#000000", align: "center" });
        this.rateBut = this.add.button(424, 400, "rateBtn2", function () {
            navigator.app.loadUrl(rateLink, { openExternal: true });
        }, this, 0, 0, 1);
        this.exitMsgTxt = this.add.text(700, 520, "No, thank you", { font: "bold 20px Arial", fill: "#000000", align: "center" });
        this.exitMsgTxt.inputEnabled = true;
        this.exitMsgTxt.events.onInputDown.add(function () {
            this.game.state.start("Level4");
        }, this);

    }

}

var boot = function (game) {
};

boot.prototype = {

    preload: function () {
        this.load.image("loading", "assets/loadProgress.png");
        this.load.image("loadingBackground", "assets/loading.png");

    },
    create: function () {
        //resizes game
        this.scale.scaleMode = Phaser.ScaleManager.USER_SCALE;
        console.log(parent.innerWidth + " " + parent.innerHeight);
        var scaleX = parent.innerWidth / this.game.width;
        var scaleY = parent.innerHeight / this.game.height;
        console.log(scaleX + " " + scaleY);
        var scaleAxis = scaleX > scaleY ? scaleX : scaleY;
        this.game.scale.setUserScale(scaleAxis, scaleY, 0, 0);
        this.game.scale.pageAlignVertically = true;
        this.game.scale.pageAlignHorizontally = true;
        console.log(this.camera.width + " " + this.camera.height);

        //loads Saved data
        this.loadInfo();
        if (this.loadedInfo === null) {
            console.log("Im here");
            saveData(1, false);
            openedLevels = 1;
            likedFB = false;
            tutorial = true;
        }
        else {
            var data = JSON.parse(this.loadedInfo);
            openedLevels = data.level;
            likedFB = data.liked;
            tutorial = false;
        }
     //   openedLevels = 5;
        this.game.state.start("mainMenu");
    },
    loadInfo: function () {
        this.loadedInfo = localStorage.getItem("savedData");
    }
}

var endScreen = function (game) { };
endScreen.prototype = {

    preload: function () {
   },
    create: function () {
        //loaded file
        console.log(openedLevels);
        this.backGroundRoom = this.add.sprite(0, 0, "backgroundMainMenu");
        this.endMsgBox = addActor(this, 162, 196, "messbox", 700, 384, 101, false, {}, {});
        this.endMsgTxt = this.add.text(205, 240, "Congratulations!\nYou escaped The Erotic Mansion!\nBut the story will be continued!\nIf you liked our game(or not)\nPlease (like) it. Also like our Facebook \npage to know everything new\n that is coming out.", { font: "bold 32px Arial", fill: "#000000", align: "center" });
        this.rateBut = this.add.button(300, 400, "rateBtn", function () {
            navigator.app.loadUrl(rateLink, { openExternal: true });
        }, this, 0, 0, 1);
        this.backBtn = this.add.button(384, 600, "backBtn", function (e) {
            this.game.state.start("mainMenu");
        }, this, 0, 0, 1);


    }

}

var ticTacGame = false;
var level1 = function (game) {
};

level1.prototype = {
    item1ID: 0,
    itemSelected: null,
    cameraMove: false,
    mouseX: 0,
    oldMouseX: 0,
    player: true,
    restarting: false,
    squares: [],
    squaresPlayers: [],
    moves: 0,
    saveOpened: false,
    picture: true,
    keyTaken: false,
    gameBeaten: false,
    preload: function () {
        //loading screen
        this.loadBck = this.add.sprite(0, 0, "loadingBackground");
        this.loadingHearts = [];
        this.atLoading = 1;
        for (var i = 0; i < 6; i++) {
            this.loadingHearts.push(this.add.sprite(133 + (i * 128), 439, "loading"));
            this.loadingHearts[i].visible = false;
        }
        game.load.onFileComplete.add(fileComplete, this);
        game.load.onLoadComplete.add(loadComplete, this);

        //secondary
        this.load.image("background", "assets/Level_1/level1Normal.png");
        this.load.image("backgroundNoSafe", "assets/Level_1/level1NoSafe.png");
        this.load.spritesheet("smallscenes", "assets/Level_1/smallscenes.png", 1024, 768);
        this.load.image("backGround", "assets/Level_1/ticTacToe/tic_tac_backgr.png");
        this.load.spritesheet("ox", "assets/Level_1/ticTacToe/ox.png", 128, 128);
        this.load.image("answer", "assets/Level_1/ticTacToe/saveBackCode.png");
        this.load.image("arrow", "assets/tutArrow.png");


    },
    create: function () {
        levelNumber = 0;
        //reseting all infor
        this.item1ID = 0;
        this.itemSelected = null;
        this.cameraMove = false;
        this.mouseX = 0;
        this.oldMouseX = 0;
        this.player = true;
        this.restarting = false;
        this.squares = [];
        this.squaresPlayers = [];
        this.moves = 0;
        this.saveOpened = false;
        this.picture = true;
        this.keyTaken = false;
        this.gameBeaten = false;
        //setUpALevel
        setUpALevel(this);
        //adds Items to HUD
        this.item1 = this.add.sprite(927, 193, "itemKey");
        this.item1.scale.setTo(1.33, 1.33);
        this.item1.fixedToCamera = true;
        this.item1.visible = false;
        this.item1.inputEnabled = true;
        this.item1.events.onInputDown.add(function (e) {
            console.log("item");

            if (e.frame === 0) {
                this.itemSelected = e;
                e.frame = 1;
            }
            else {
                e.frame = 0;
                this.itemSelected = null;
            }

        }, this);
        //adds the text for the safe
        this.saveText = this.add.text(400, 80, "", { font: "42px Arial", fill: "#ffffff", align: "center" });

        //adds all the clickable items
        //shkaf
        this.shkaf = addActor(this, 304, 306, "camera", 60, 92, 1, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            ticTac: ticTacGame
        });
        //safe;
        this.safe = addActor(this, 887, 146, "camera", 140, 102, 2, true, this.removePicture, {
            event: this,
            scene: this.smallScene,
            ticTac: ticTacGame
        });
        //snimka
        this.snimka = addActor(this, 1085, 80, "camera", 85, 189, 5, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            ticTac: ticTacGame
        });
        //iPad
        this.iPad = addActor(this, 126, 539, "camera", 280, 54, 10, true, function () {
            if (this.smallScene.id == 1) {
                this.cameraMan.x = 512;
                this.makeTicTacToe();
            }

        }, this);
        //key
        this.key = addActor(this, 402, 585, "camera", 108, 70, 3, true, this.takeKey, {
            event: this,
            scene: this.smallScene,
            ticTac: ticTacGame
        });
        //door
        this.door = addActor(this, 1338, 55, "camera", 117, 606, 11, true, function () {
            if (this.itemSelected !== null) {
                openedLevels = 2;
                saveData(2, likedFB);
                this.game.state.start("Level2");
            }
        }, this);
        //tutorial
        if (tutorial) {
            this.tutArrow = addActor(this, 256, 64, "arrow", 512, 128, 101, false, {}, {});
            this.tutMess = addActor(this, 256, 196, "messbox", 512, 200, 101, false, {}, {});
            this.tutMessTxt = this.add.text(280, 230, "SLIDE TO LOOK \nAROUND THE ROOM", { font: "bold 46px Arial", fill: "#000000", align: "center" });
        }
        //brings the smallscene to the top
        this.smallScene.bringToTop();

    },
    update: function () {
        if (this.cameraMove && this.smallScene.shown === false && !ticTacGame) {
            if (tutorial) {
                this.tutArrow.destroy();
                this.tutMess.destroy();
                this.tutMessTxt.destroy();
            }
            this.mouseX = this.input.x;
            this.cameraMan.x = this.cameraMan.x - (this.mouseX - this.oldMouseX);
            if (this.cameraMan.x > 1024)
                this.cameraMan.x = 1024;
            if (this.cameraMan.x < 512)
                this.cameraMan.x = 512;

            this.oldMouseX = this.mouseX;
        }

        if (ticTacGame) {
            if (!this.player && !this.restarting) {
                if (!this.checkIfWin(1)) {
                    if (this.moves < 5) {
                        this.makeMove();
                        if (!this.checkIfWin(2))
                            this.player = true;
                        else {
                            this.restarting = true;
                            console.log(this.squaresPlayers[8]);
                            window.setTimeout(this.restart, 1000, this);
                        }
                    }
                    else {
                        console.log(this.squaresPlayers[8]);
                        this.restarting = true;
                        window.setTimeout(this.restart, 1000, this);
                    }
                }
                else {
                    this.backGround.loadTexture("answer");
                    this.gameBeaten = true;
                    this.backGround.bringToTop();
                    this.backBtn.bringToTop();
                }
            }

        }

        if (this.smallScene.shown === false)
            this.saveText.setText("");

        this.HUD.bringToTop();
        this.item1.bringToTop();
    },

    //ticTacMiniGame
    makeTicTacToe: function () {
        ticTacGame = true;
        if (!this.gameBeaten) {
            for (var i = 0; i < 3; i++) {
                this.squares[i] = this.add.sprite(284 + i * 168, 136, "ox");
                this.squares[i].inputEnabled = true;
                this.squares[i].events.onInputDown.add(this.takeInput, { index: i, event: this });
                this.squaresPlayers[i] = 0;
            }
            for (var i = 0; i < 3; i++) {
                this.squares[3 + i] = this.add.sprite(284 + i * 168, 304, "ox");
                this.squares[3 + i].inputEnabled = true;
                this.squares[3 + i].events.onInputDown.add(this.takeInput, { index: 3 + i, event: this });
                this.squaresPlayers[3 + i] = 0;
            }
            for (var i = 0; i < 3; i++) {
                this.squares[6 + i] = this.add.sprite(284 + i * 168, 472, "ox");
                this.squares[6 + i].inputEnabled = true;
                this.squares[6 + i].events.onInputDown.add(this.takeInput, { index: 6 + i, event: this });
                this.squaresPlayers[6 + i] = 0;
            }
            this.backGround = this.add.sprite(0, 0, "backGround");
            this.backBtn = this.add.button(10, 630, "backBtn", function () {
                this.destroyTicTac();
                this.backBtn.kill();
                this.backBtn = null;
            }, this, 0, 0, 1);
        }
        else {
            this.backGround = this.add.sprite(0, 0, "answer");
            this.backBtn = this.add.button(10, 630, "backBtn", function () {
                this.destroyTicTac();
                this.backBtn.kill();
                this.backBtn = null;
            }, this, 0, 0, 1);
        }

    },

    takeInput: function (e) {
        console.log(ticTacGame);
        if (this.event.player && this.event.squaresPlayers[this.index] === 0) {
            this.event.moves++;
            e.frame = 1;
            e.bringToTop();
            this.event.player = false;
            this.event.squaresPlayers[this.index] = 1;
        }
    },

    checkIfWin: function (player) {
        for (var i = 0; i < 8; i = i + 3) {
            if (this.squaresPlayers[i] === player && this.squaresPlayers[i + 1] === player && this.squaresPlayers[i + 2] === player)
                return true;
        }
        for (var i = 0; i < 3; i++) {
            if (this.squaresPlayers[i] === player && this.squaresPlayers[i + 3] === player && this.squaresPlayers[i + 6] === player)
                return true;
        }
        if (this.squaresPlayers[0] === player && this.squaresPlayers[4] === player && this.squaresPlayers[8] === player)
            return true;
        if (this.squaresPlayers[2] === player && this.squaresPlayers[4] === player && this.squaresPlayers[6] === player)
            return true;
        return false;
    },

    makeMove: function () {

        var ready = false;
        var pos = 0;
        for (var i = 0; i < 9; i++) {
            if (ready === false)
                if (this.squaresPlayers[i] === 0) {
                    this.squaresPlayers[i] = 2;
                    if (!this.checkIfWin(2)) {
                        this.squaresPlayers[i] = 0;
                    }
                    else {
                        ready = true;
                        this.squares[i].bringToTop();
                    }
                }
        }

        if (!ready) {
            for (var i = 0; i < 9; i++) {
                if (ready === false)
                    if (this.squaresPlayers[i] === 0) {
                        this.squaresPlayers[i] = 1;
                        if (!this.checkIfWin(1)) {
                            this.squaresPlayers[i] = 0;
                        }
                        else {
                            ready = true;
                            this.squaresPlayers[i] = 2;
                            this.squares[i].bringToTop();
                        }
                    }
            }
        }
        while (!ready) {
            var ind = Math.floor(Math.random() * 9);
            if (this.squaresPlayers[ind] === 0) {
                this.squaresPlayers[ind] = 2;
                this.squares[ind].bringToTop();
                ready = true;
            }

        }


    },

    restart: function (event) {
        console.log(event);
        for (var i = 0; i < 9; i++) {
            event.squaresPlayers[i] = 0;
            event.squares[i].frame = 0;
        }
        event.backGround.bringToTop();
        event.backBtn.bringToTop();
        event.player = true;
        event.restarting = false;
        event.moves = 0;
    },

    destroyTicTac: function () {
        this.backGround.destroy();
        for (var i = 0; i < 9; i++)
            this.squares[i].destroy();
        ticTacGame = false;
    },

    //handlers
    changeSmallScenes: function (e) {
        if (!this.scene.shown && !ticTacGame) {
            //resets cameraview
            this.event.cameraMan.x = 512;
            //shows the small scenes
            this.scene.width = 1024;
            this.scene.height = 768;
            this.scene.id = e.id;
            this.scene.frame = e.id - 1;
            this.scene.shown = true;
            if (e.id == 1)
                this.event.iPad.bringToTop();
            if (e.id == 2) {
                this.event.world.bringToTop(this.event.saveText);
                if (this.event.keyTaken)
                    this.scene.frame = 3;
            }
            //adds back Btnton
            var backBtn = this.event.add.button(10, 630, "backBtn", backBtnHandler, {
                event: this.event,
                scene: this.scene
            }, 0, 0, 1);
        }
    },

    removePicture: function () {
        console.log("Pic");
        if (this.event.picture) {
            this.event.picture = false;
            this.event.backGroundRoom.loadTexture("backgroundNoSafe");
            this.event.safe.events.onInputDown.add(this.event.changeSmallScenes, {
                event: this.event,
                scene: this.scene,
                ticTac: ticTacGame
            });
        }

    },

    takeKey: function () {
        if (this.event.saveOpened) {
            this.event.item1ID = 1;
            this.event.smallScene.frame = 3;
            this.event.keyTaken = true;
            this.event.item1.visible = true;
        }
    },

    handleSmallScenes: function () {
        if (this.gamePointer.smallScene.id === 2) {
            if (this.gamePointer.saveText.text.length > 6)
                this.gamePointer.saveText.setText("");
            else {
                var pressed = findNumber(this.gamePointer.game.input.x, this.gamePointer.game.input.y);
                console.log(this.gamePointer.game.input.x + " " + this.gamePointer.game.input.y);
                if (pressed >= 0 && pressed < 10)
                    this.gamePointer.saveText.setText(this.gamePointer.saveText.text + pressed);

                if (pressed === 12) {
                    if (this.gamePointer.saveText.text === " 1227") {
                        this.gamePointer.saveOpened = true;
                        this.gamePointer.key.bringToTop();
                        this.gamePointer.smallScene.frame = 2;
                        this.gamePointer.saveText.setText("");
                    }
                    else
                        this.gamePointer.saveText.setText("");
                }
            }
        }

        console.log(this.gamePointer.game.input.x + " " + this.gamePointer.game.input.y);
    }
};

function saveData(level, liked) {
    localStorage.setItem("savedData", JSON.stringify({
        "level": level,
        "liked": liked
    }));
}

function fileComplete(progress, cacheKey, success, totalLoaded, totalFiles) {
    if (progress > this.atLoading * 17) {
        this.loadingHearts[this.atLoading - 1].visible = true;
        this.atLoading++;
    }
}

function loadComplete() {
    this.loadBck.destroy();
    for (var i = 0; i < 6; i++)
        this.loadingHearts[i].destroy();
}

function backBtnHandler(e) {
    this.scene.width = 0;
    this.scene.height = 0;
    this.scene.id = -1;
    this.scene.shown = false;
    e.kill();
    e = null;
}

function findNumber(x, y) {
    if (x > 386 && x < 444 && y > 191 && y < 255)
        return 1;
    if (x > 490 && x < 567 && y > 191 && y < 255)
        return 2;
    if (x > 614 && x < 690 && y > 191 && y < 255)
        return 3;
    if (x > 386 && x < 444 && y > 300 && y < 363)
        return 4;
    if (x > 490 && x < 567 && y > 300 && y < 363)
        return 5;
    if (x > 614 && x < 690 && y > 300 && y < 363)
        return 6;
    if (x > 386 && x < 444 && y > 410 && y < 473)
        return 7;
    if (x > 490 && x < 567 && y > 410 && y < 473)
        return 8;
    if (x > 614 && x < 690 && y > 410 && y < 473)
        return 9;
    if (x > 490 && x < 567 && y > 518 && y < 580)
        return 0;
    /*    if (x > 437 && x < 492 && y > 526 && y < 584)
            return 11;*/ //no cleaning
    if (x > 377 && x < 684 && y > 638 && y < 698)
        return 12;

    return 10;
}

function addActor(game, x, y, img, width, height, id, inputEnabled, handler, objForHandler) {
    retV = game.add.sprite(x, y, img);
    retV.width = width;
    retV.height = height;
    retV.id = id;
    if (inputEnabled) {
        retV.inputEnabled = inputEnabled;
        retV.events.onInputDown.add(handler, objForHandler);
    }

    return retV;
}

function setUpALevel(game) {
    hintShown = false;
    game.world.setBounds(0, 0, 1536, 768);
    //adds background
    game.backGroundRoom = game.add.sprite(0, 0, "background");
    //adds BackToMenuButton and MuteButton
    game.backToMenu = game.add.button(0, 0, "backToMenuBtn", function () {
        game.state.start("mainMenu");
    }, this, 0, 0, 1);
    game.backToMenu.fixedToCamera = true;
    //adds helpBtn
    game.helpBtn = game.add.button(200, 0, "helpBtn", function () { //924 28
        showHint(game, "Follow this link to see full\nwritten walkthrough and\n video walkthrough for the level");
    }, this, 0, 0, 1);
    game.helpBtn.fixedToCamera = true;
    //adds FBLike Btn
    game.fbBtn = game.add.button(310, 16, "fbBtn", function () { //924 28
        navigator.app.loadUrl(fbLinkToPage, { openExternal: true });
    }, this, 0, 0, 1);
    game.fbBtn.fixedToCamera = true;
    //add- va muted butona s malko workaround zashtoto ne zarejda kato horata frame- a
    var muteBtnRcr = "unmuted";
    game.muteBtn = addActor(game, 100, 0, muteBtnRcr, 100, 100, 1001, true, function (e) {  },game);
    game.muteBtn.fixedToCamera = true;
    //adds camera info and moving
    game.cameraMan = game.add.sprite(512, game.world.centerY, "camera");
    game.camera.follow(game.cameraMan);
    game.backGroundRoom.inputEnabled = true;
    game.backGroundRoom.events.onInputDown.add(function () {
        game.cameraMove = true;
        game.oldMouseX = game.input.x;
    }, game);
    game.backGroundRoom.events.onInputUp.add(function () {
        game.cameraMove = false;
    }, game);
    //adds HUD
    game.HUD = game.add.sprite(902, 126, "HUD");
    game.HUD.fixedToCamera = true;
    game.HUD.inputEnabled = true;

    //adds smallcene manager
    game.smallScene = game.add.sprite(0, 0, "smallscenes");
    game.smallScene.id = -1;
    game.smallScene.width = 0;
    game.smallScene.height = 0;
    game.smallScene.shown = false;
    game.smallScene.inputEnabled = true;
    game.smallScene.events.onInputDown.add(game.handleSmallScenes, {
        event: game,
        scene: game.smallScene,
        gamePointer: game
    });
}

function makeHUDItems(game) {
    game.hudItems = [];
    game.hudItems.push(game.add.sprite(927, 191, "itemKey"));
    game.hudItems.push(game.add.sprite(927, 287, "itemKey"));
    game.hudItems.push(game.add.sprite(927, 385, "itemKey"));
    game.hudItems.push(game.add.sprite(927, 483, "itemKey"));
    game.selector = game.add.sprite(927, 0, "selector");
    game.selector.scale.setTo(1.33, 1.33);
    game.selector.visible = false;
    game.selector.fixedToCamera = true;
    for (var i = 0; i < game.hudItems.length; i++) {
        game.hudItems[i].scale.setTo(1.33, 1.33);
        game.hudItems[i].fixedToCamera = true;
        game.hudItems[i].inputEnabled = true;
        game.hudItems[i].events.onInputDown.add(handleHUDItems, { event: game });
        game.hudItems[i].visible = false;
        game.hudItems[i].id = null;
    }

}

function handleHUDItems(e) {
    if (this.event.itemSelected === null) {
        this.event.selector.x = 927;
        this.event.selector.y = e.y;
        this.event.selector.visible = true;
        this.event.selector.fixedToCamera = true;
        this.event.itemSelected = e;
    }
    else {
        if (!canTheyCombine(this.event.itemSelected, e, this.event)) {
            this.event.selector.visible = false;
            this.event.itemSelected = null;
        }
    }
    console.log(this.event.selector.x + " " + this.event.selector.y);
}

function takeItem(e) {
    var taken = false;
    for (var i = 0; i < this.game.hudItems.length; i++) {
        if (!taken && this.game.hudItems[i].id === null) {
            taken = true;
            this.game.hudItems[i].id = e.id;
            this.game.hudItems[i].loadTexture(e.id);
            this.game.hudItems[i].visible = true;
            e.taken = true;
            e.kill();
        }
    }
}

function addTakableItem(actor, visible) {
    actor.visible = visible;
    actor.taken = false;
    return actor;
}

function removeItemFromHUD(game) {
    game.selector.visible = false;
    game.itemSelected.visible = false;
    game.itemSelected.id = null;
    game.itemSelected = null;
}

function canTheyCombine(e1, e2, game) {
    var combinations = [["102 103", 106], ["105 106", 107]];
    for (var i = 0; i < combinations.length; i++) {
        if ((e1.id + " " + e2.id) === combinations[i][0] || (e2.id + " " + e1.id) === combinations[i][0]) {
            game.selector.visible = false;
            game.itemSelected.visible = false;
            game.itemSelected.id = null;
            game.itemSelected = null;
            e2.id = combinations[i][1];
            e2.loadTexture(e2.id);
            return true;
        }
    }
    return false;
}

function takeItemIndirectly(e, game) {
    var taken = false;
    for (var i = 0; i < game.hudItems.length; i++) {
        if (!taken && game.hudItems[i].id === null) {
            taken = true;
            game.hudItems[i].id = e.id;
            game.hudItems[i].loadTexture(e.id);
            game.hudItems[i].visible = true;
            e.taken = true;
            e.kill();
        }
    }
}

function showHint(game, msg) {
    if (!hintShown) {
        hintShown = true;
        game.endMsgBox = addActor(game, 256, 196, "messbox", 512, 384, 101, true, function (e) {
            this.hintMsgTxt.destroy();
            this.fbHintBtn.destroy();
            e.destroy();
            hintShown = false;
        }, game);
        game.endMsgBox.fixedToCamera = true;
        game.hintMsgTxt = game.add.text(268, 260, msg, { font: "bold 32px Arial", fill: "#000000", align: "center" });
        game.hintMsgTxt.fixedToCamera = true;
        game.fbHintBtn = game.add.button(410, 430, "hintsBtn", function () {
            //open the links
            if(adLoaded){
                window.adcolony.showFullScreenAd();
            }
            else{
                navigator.app.loadUrl(levelFbLinks[levelNumber], { openExternal: true });
            }
        }, this, 0, 0, 1);
        game.fbHintBtn.fixedToCamera = true;
    }

}

var level2 = function (game) { };
level2.prototype = {
    cameraMove: false,
    paused: false,
    mouseX: 0,
    oldMouseX: 0,
    colours: [0xffffff, 0, 1, 2],
    atColour: 0,
    itemSelected: null,
    preload: function () {
        //loading screen
        this.loadBck = this.add.sprite(0, 0, "loadingBackground");
        this.loadingHearts = [];
        this.atLoading = 1;
        for (var i = 0; i < 6; i++) {
            this.loadingHearts.push(this.add.sprite(133 + (i * 128), 439, "loading"));
            this.loadingHearts[i].visible = false;
        }
        game.load.onFileComplete.add(fileComplete, this);
        game.load.onLoadComplete.add(loadComplete, this);
        //secondary
        this.load.image("background", "assets/Level_2/background.png");
        this.load.image("key", "assets/Level_2/key2.png");
        this.load.spritesheet("smallscenes", "assets/Level_2/smallscenes.png", 1024, 768);
        this.load.spritesheet("numbers", "assets/Level_2/numbers.png", 64, 64);
        this.load.spritesheet("labels", "assets/Level_2/labels.png", 60, 33);

        //smallGame
        this.load.spritesheet("cards", "assets/Level_2/smallCardGame/cardsSprite.png", 110, 110);
        this.load.spritesheet("laptopdesktop", "assets/Level_2/smallCardGame/laptopSprite.png", 854, 534);

    },
    create: function () {
        levelNumber = 1;
        //reseting
        this.cameraMove= false;
        this.paused = false;
        this.mouseX = 0;
        this.oldMouseX = 0;
        this.atColour = 0;
        this.itemSelected = null;
        //setUpALevel
        setUpALevel(this);
        //cards for miniGame
        this.turnedCards = [];
        this.rdyToTurn = false;
        this.pairs = 8;
        //items for HUD
        this.item1 = this.add.sprite(927, 193, "itemKey");
        this.item1.scale.setTo(1.33, 1.33);
        this.item1.fixedToCamera = true;
        this.item1.visible = false;
        this.item1.inputEnabled = true;
        this.item1.events.onInputDown.add(function (e) {
            
            if (e.frame === 0) {
                e.frame = 1;
                this.itemSelected = e;
            }
            else {
                e.frame = 0;
                this.itemSelected = null;
            }

        }, this);
        //items
        //laptop
        this.laptop = addActor(this, 705, 458, "camera", 90, 58, 1, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //door
        this.door = addActor(this, 665, 182, "camera", 188, 280, 7, true, function () {
            if (this.itemSelected !== null) {
                openedLevels = 3;
                saveData(3, likedFB);
                this.game.state.start("Level3");
            }
        }, this);
        this.door.visible = false;
        //shkaf
        this.shkaf = addActor(this, 507, 236, "camera", 147, 202, 3, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //kalendar
        this.kalendar = addActor(this, 1167, 200, "camera", 195, 250, 2, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //kutiqSKod
        this.kutiq = addActor(this, 425, 404, "camera", 179, 80, 8, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //klyuch
        this.key = addActor(this, 405, 411, "key", 300, 128, 8, true, function (e) {
            this.event.door.visible = true;
            this.event.item1.itemID = 1;
            this.event.item1.visible = true;
            e.kill();
        }, {
            event: this,
            scene: this.smallScene
        });
        this.key.visible = false;
        //coolNumbers
        this.num1 = addActor(this, 377, 428, "numbers", 64, 64, 13, true, this.increaseNumber, this);
        this.num1.visible = false;
        this.num2 = addActor(this, 498, 428, "numbers", 64, 64, 14, true, this.increaseNumber, this);
        this.num2.visible = false;
        this.num3 = addActor(this, 618, 428, "numbers", 64, 64, 15, true, this.increaseNumber, this);
        this.num3.visible = false;
        //adds gameButtonLaptop
        this.gameBtn = addActor(this, 200, 154, "camera", 256, 256, 9, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //adds coloursLaptop
        this.colourLaptop1 = addActor(this, 219, 176, "camera", 162, 164, 10, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        this.colourLaptop1.visible = false;
        this.colourLaptop2 = addActor(this, 431, 176, "camera", 162, 164, 11, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        this.colourLaptop2.visible = false;
        this.colourLaptop3 = addActor(this, 641, 176, "camera", 162, 164, 12, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        this.colourLaptop3.visible = false;
        //adds showCollours
        this.showColour = [];
        this.showColour.push(addActor(this, 382, 404, "labels", 62, 33, 16, false, {}, {}));
        this.showColour.push(addActor(this, 448, 404, "labels", 62, 33, 16, false, {}, {}));
        this.showColour.push(addActor(this, 514, 404, "labels", 62, 33, 16, false, {}, {}));
        this.showColour.push(addActor(this, 581, 404, "labels", 62, 33, 16, false, {}, {}));
        this.showColour.push(addActor(this, 382, 444, "labels", 62, 33, 16, false, {}, {}));
        this.showColour.push(addActor(this, 448, 444, "labels", 62, 33, 16, false, {}, {}));
        this.showColour.push(addActor(this, 514, 444, "labels", 62, 33, 16, false, {}, {}));
        this.showColour.push(addActor(this, 581, 444, "labels", 62, 33, 16, false, {}, {}));

        for (var i = 0; i < this.showColour.length; i++) {
            this.showColour[i].col = 0;
            this.showColour[i].visible = false;
            //changes the colour s 16- no 4islo
            this.showColour[i].frame = 0;
        }


    },
    update: function () {
        if (!this.paused) {
            if (this.cameraMove && !this.smallScene.shown) {
                this.mouseX = this.input.x;
                this.cameraMan.x = this.cameraMan.x - (this.mouseX - this.oldMouseX);
                if (this.cameraMan.x > 1024)
                    this.cameraMan.x = 1024;
                if (this.cameraMan.x < 512)
                    this.cameraMan.x = 512;
                this.oldMouseX = this.mouseX;
            }
            if (this.smallScene.id === 8 && this.num1.frame === 3 && this.num2.frame === 7 && this.num3.frame === 6) {
                this.smallScene.id = 9;
                this.smallScene.frame = 4;
                this.num1.visible = false;
                this.num2.visible = false;
                this.num3.visible = false;
                this.key.visible = true;
            }
            if (this.atColour === 8) {
                console.log(this.smallScene.id + " " + this.showColour[0].frame + " " + this.showColour[1].frame + " " +
                this.showColour[2].frame + " " + this.showColour[3].frame + " " + this.showColour[4].frame + " " + this.showColour[5].frame + " " +
                this.showColour[6].frame + " " + this.showColour[7].frame)
                if (this.smallScene.id === 1 && this.showColour[0].frame === 2 && this.showColour[1].frame === 2 &&
                this.showColour[2].frame === 1 && this.showColour[3].frame === 2 && this.showColour[4].frame === 2 && this.showColour[5].frame === 2 &&
                this.showColour[6].frame === 2 && this.showColour[7].frame === 2) {
                    this.smallScene.id = 6;
                    this.smallScene.frame = 5;
                    this.gameBtn.bringToTop();
                    for (var i = 0; i < this.showColour.length; i++) {
                        this.showColour[i].visible = false;
                    }
                }
                else {
                    for (var i = 0; i < this.showColour.length; i++) {
                        this.showColour[i].frame = 0;
                        this.atColour = 0;
                    }
                }
            }
        }
        if (this.paused) {
            if (this.turnedCards.length === 2 && !this.rdyToTurn) {
                this.rdyToTurn = true;
                if (this.turnedCards[0].num === this.turnedCards[1].num) {
                    window.setTimeout(function (game) {
                        game.turnedCards[0].kill();
                        game.turnedCards[1].kill();
                        game.turnedCards.length = 0;
                        game.rdyToTurn = false;
                        game.pairs--;
                        if (game.pairs === 0) {
                            game.smallGameBckGround.frame = 1;
                        }
                        console.log(game.pairs);
                    }, 1000, this);
                }
                else {
                    window.setTimeout(function (game) {
                        game.turnedCards[0].frame = 0;
                        game.turnedCards[1].frame = 0;
                        game.turnedCards.length = 0;
                        game.rdyToTurn = false;
                    },1000, this);
                }
            }
        }

        this.HUD.bringToTop();
        this.item1.bringToTop();
    },
    //handlers
    changeSmallScenes: function (e) {
        if (!this.scene.shown && !this.paused) {
            //resets cameraview
            this.event.cameraMan.x = 512;
            //shows the small scenes
            this.scene.width = 1024;
            this.scene.height = 768;
            this.scene.id = e.id;
            this.scene.frame = e.id - 1;
            this.scene.shown = true;
            //adds back Btnton
            var backBtn = this.event.add.button(10, 630, "backBtn", this.event.backBtnHandler, {
                event: this.event,
                scene: this.scene
            }, 0, 0, 1);

            if(e.id===1){
                for (var i = 0; i < this.event.showColour.length; i++) {
                    this.event.showColour[i].visible = true;
                    this.event.showColour[i].bringToTop();
                }
                this.event.colourLaptop1.visible = true;
                this.event.colourLaptop2.visible = true;
                this.event.colourLaptop3.visible = true;
                this.event.colourLaptop1.bringToTop();
                this.event.colourLaptop2.bringToTop();
                this.event.colourLaptop3.bringToTop();
            }
        }
    },
    handleSmallScenes: function (e) {
        //otvarq koda za safe-a
        if (e.id == 8 && this.scene.id == 3 && !this.event.paused) {
            this.scene.id = e.id;
            this.scene.frame = 3;
            this.event.num1.visible = true;
            this.event.num1.bringToTop();
            this.event.num2.visible = true;
            this.event.num2.bringToTop();
            this.event.num3.visible = true;
            this.event.num3.bringToTop();
        }
        //puska igrata
        if (e.id === 9 && this.scene.id == 6 && !this.event.paused) {
            this.event.paused = true;
            this.event.createSmallCardGame();
        }
        //opravq cvetovete na laptopa
        if ((e.id === 10 || e.id === 11 || e.id === 12) && this.scene.id === 1 && !this.event.paused) {
            if (this.event.atColour < 8) {
                this.event.showColour[this.event.atColour].frame = e.id-9;
                this.event.atColour++;
            }
        }

    },
    backBtnHandler: function (e) {
        if (!this.event.paused) {
            if (this.scene.id === 8) {
                this.event.num1.visible = false;
                this.event.num2.visible = false;
                this.event.num3.visible = false;
            }
            if (this.scene.id === 1) {
                for (var i = 0; i < this.event.showColour.length; i++) {
                    this.event.showColour[i].visible = false;
                    this.event.showColour[i].tint = this.event.colours[0];
                    this.event.atColour = 0;
                }
                this.event.colourLaptop1.visible = false;
                this.event.colourLaptop2.visible = false;
                this.event.colourLaptop3.visible = false;
            }
            if (this.scene.id === 9) {
                this.event.key.visible = false;
            }
        }
        else
            this.event.destroySmallCardGame(this.event);

        this.event.shkaf.bringToTop();
        this.event.door.bringToTop();
        this.scene.width = 0;
        this.scene.height = 0;
        this.scene.id = -1;
        this.scene.shown = false;
        e.kill();
        e = null;
    },
    increaseNumber: function (e) {
        if (e.frame === 9)
            e.frame = 0;
        else e.frame++;
    },
    createSmallCardGame: function () {
        this.smallGameBckGround = addActor(this, 123, 53, "laptopdesktop", 804, 507, 17, false, {}, {});
        this.cards = [];
        this.pairs = 8;
        this.turnedCards = [];
        this.rdyToTurn = false;
        var x = 290; //125
        var y = 63;
        for (var i = 0; i < 16; i++) {
            if (i % 4 === 0 && i != 0) {
                x = 290;
                y += 125
            }
            this.cards.push(addActor(this, x, y, "cards", 110, 110, 18, true, function (e) {
                if (this.turnedCards.length < 2 && e.frame===0) {
                    e.frame = e.num;
                    this.turnedCards.push(e);
                }
            }, this));
            x += 125;
        }
        var num = 0;
        var turn = 1;
        while (num < 8) {
            var i = Math.floor(Math.random() * 16);
            if (this.cards[i].num === undefined) {
                this.cards[i].num = num + 1;
                turn++;
            }
            if (turn === 3) {
                turn = 1;
                num++;
            }
        }

    },
    destroySmallCardGame: function (game) {
        game.smallGameBckGround.destroy();
        for (var i = 0; i < game.cards.length; i++)
            game.cards[i].destroy();
        game.paused = false;
    }

}

var level3 = function (game) { };
level3.prototype = {
    cameraMove: false,
    paused: false,
    kilimUp: false,
    accessKey: false,
    keyTaken: false,
    itemSelected: null,
    atLevel:0,
    mouseX: 0,
    oldMouseX: 0,
    colours: [0xffffff, 0xC60E0E, 0x36A30B, 0x0202fd],
    preload: function () {
        //loading screen
        this.loadBck = this.add.sprite(0, 0, "loadingBackground");
        this.loadingHearts = [];
        this.atLoading = 1;
        for (var i = 0; i < 6; i++) {
            this.loadingHearts.push(this.add.sprite(133 + (i * 128), 439, "loading"));
            this.loadingHearts[i].visible = false;
        }
        game.load.onFileComplete.add(fileComplete, this);
        game.load.onLoadComplete.add(loadComplete, this);
        //secondary
        this.load.image("background", "assets/Level_3/level4Carpet.png");
        this.load.image("backgroundUp", "assets/Level_3/level4.png");
        this.load.spritesheet("smallscenes", "assets/Level_3/smallscenes.png", 1024, 768);
        this.load.image("key", "assets/Level_3/key.png");
        this.load.image("text", "assets/Level_3/zadachka.png");

        //load smallGameShits
        this.load.image("backgroundSmallGame", "assets/Level_3/smallGame/iPadBackLevel3.png");
        this.load.image("backgroundSmallGameLevel2", "assets/Level_3/smallGame/Level3RiddleFull.png");
        this.load.spritesheet("numbers", "assets/Level_2/numbers.png", 64, 64);
        this.load.image("enterBtn", "assets/Level_3/smallGame/enterBut.png");
        this.load.image("answer", "assets/Level_3/smallGame/answer.png");
        this.load.image("19", "assets/Level_3/smallGame/allthe.png");
        this.load.image("15", "assets/Level_3/smallGame/alotof.png");
        this.load.image("4", "assets/Level_3/smallGame/apple.png");
        this.load.image("18", "assets/Level_3/smallGame/ate.png");
        this.load.image("11", "assets/Level_3/smallGame/awesome.png");
        this.load.image("10", "assets/Level_3/smallGame/crossed.png");
        this.load.image("2", "assets/Level_3/smallGame/drank.png");
        this.load.image("empty", "assets/Level_3/smallGame/empty.png");
        this.load.image("7", "assets/Level_3/smallGame/green.png");
        this.load.image("9", "assets/Level_3/smallGame/I.png");
        this.load.image("6", "assets/Level_3/smallGame/loved.png");
        this.load.image("5", "assets/Level_3/smallGame/noone.png");
        this.load.image("1", "assets/Level_3/smallGame/one.png");
        this.load.image("16", "assets/Level_3/smallGame/pie.png");
        this.load.image("12", "assets/Level_3/smallGame/pineapple.png");
        this.load.image("14", "assets/Level_3/smallGame/ran.png");
        this.load.image("3", "assets/Level_3/smallGame/some.png");
        this.load.image("13", "assets/Level_3/smallGame/thesquareroot.png");
        this.load.image("17", "assets/Level_3/smallGame/thesquirrel.png");
        this.load.image("20", "assets/Level_3/smallGame/watermelon.png");
        this.load.image("8", "assets/Level_3/smallGame/wine.png");


    },
    create: function () {
        levelNumber = 2;
        //reseting all info
        this.cameraMove= false;
        this.paused = false;
        this.kilimUp = false;
        this.accessKey = false;
        this.keyTaken = false;
        this.itemSelected = null;
        this.atLevel = 0;
        this.mouseX = 0;
        this.oldMouseX = 0;
        setUpALevel(this);
        //items for HUD
        this.item1 = this.add.sprite(927, 193, "itemKey");
        this.item1.scale.setTo(1.33, 1.33);
        this.item1.fixedToCamera = true;
        this.item1.visible = false;
        this.item1.inputEnabled = true;
        this.item1.events.onInputDown.add(function (e) {

            if (e.frame === 0) {
                e.frame = 1;
                this.itemSelected = e;
            }
            else {
                e.frame = 0;
                this.itemSelected = null;
            }

        }, this);

        //items
        //shisheta
        this.shisheta = addActor(this, 1093, 497, "camera", 94, 59, 1, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //kilim
        this.kilim = addActor(this, 1065, 600, "camera", 81, 76, 21, true, function () {
            this.kilimUp = true;
            //safe
            this.safe = addActor(this, 776, 619, "camera", 153, 43, 2, true, this.changeSmallScenes, {
                event: this,
                scene: this.smallScene
            });
            this.backGroundRoom.loadTexture("backgroundUp");
        }, this);
        //knigi
        this.knigi = addActor(this, 646, 241, "camera", 128, 64, 5, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //chekmedje
        this.chekmedje = addActor(this, 290, 473, "camera", 85, 90, 3, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //gotina snimka 1
        this.gotinaSnimka1 = addActor(this, 463, 215, "camera", 143, 110, 7, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //gotina snimka 2
        this.gotinaSnimka2 = addActor(this, 979, 412, "camera", 67, 63, 8, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //iPad
        this.iPad = addActor(this, 401, 359, "camera", 227, 179, 22, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        this.iPad.visible = false;
        //theKeyBook
        this.theKeyBook = addActor(this, 226, 235, "camera", 45, 294, 6, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //theTask
        this.theTask = addActor(this, 412, 282, "camera", 392, 205, 9, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        this.theTask.visible = false;
        //theTaskText
        this.theTaskText = addActor(this, 128, 192, "text", 768, 384, 10, true, function (e) {
            e.visible = false;
        }, this);
        this.theTaskText.visible = false;
        //theDoor
        this.theDoor = addActor(this, 2, 131, "camera", 58, 584, 11, true, function () {
            if (this.itemSelected !== null) {
                openedLevels = 4;
                saveData(4, likedFB);
                this.game.state.start("after3rdLevelScreen");
            }
        }, this);
        //answerToGame
        this.answerToGame = addActor(this, 172, 214, "answer", 512, 256, 10, false, {}, {});
        this.answerToGame.scale.setTo(1.33, 1.33);
        this.answerToGame.visible = false;
        //key
        this.key = addActor(this, 487, 400, "key", 256, 256, 5, true, function (e) {
            this.keyTaken = true;
            this.item1.itemID = 1;
            this.item1.visible = true;
            e.kill();
        }, this);
        this.key.visible = false;
        //adds showCollours
        this.showColour = [];
        this.showColour.push(addActor(this, 403, 335, "tester", 50, 78, 16, true, function (e) {
            e.col = ((e.col + 1) % 3) + 1;
            e.tint = this.colours[e.col];
        }, this));
        this.showColour.push(addActor(this, 491, 337, "tester", 50, 78, 16, true, function (e) {
            e.col = ((e.col + 1) % 3) + 1;
            e.tint = this.colours[e.col];
        }, this));
        this.showColour.push(addActor(this, 576, 337, "tester", 50, 78, 16, true, function (e) {
            e.col = ((e.col + 1) % 3) + 1;
            e.tint = this.colours[e.col];
        }, this));
        this.showColour.push(addActor(this, 662, 337, "tester", 50, 78, 16, true, function (e) {
            e.col = ((e.col + 1) % 3) + 1;
            e.tint = this.colours[e.col];
        }, this));
        for (var i = 0; i < this.showColour.length; i++) {
            this.showColour[i].col = 0;
            this.showColour[i].visible = false;
            //changes the colour s 16- no 4islo
            this.showColour[i].tint = this.colours[this.showColour[i].col];
        }

    },
    update: function () {
        if (!this.paused) {
            if (this.cameraMove && !this.smallScene.shown) {
                this.mouseX = this.input.x;
                this.cameraMan.x = this.cameraMan.x - (this.mouseX - this.oldMouseX);
                if (this.cameraMan.x > 1024)
                    this.cameraMan.x = 1024;
                if (this.cameraMan.x < 512)
                    this.cameraMan.x = 512;
                this.oldMouseX = this.mouseX;
            }

            if (this.smallScene.id === 2 && this.showColour[0].col === 2 && this.showColour[1].col === 1 && this.showColour[2].col === 3 && this.showColour[3].col === 2) {
                this.smallScene.id = 4;
                this.smallScene.frame = 3;
                this.iPad.visible = true;
                this.iPad.bringToTop();
                this.showHideColors(this.showColour, false);
            }
        }
        else {
            if (this.givenAnswers[0].answerID === 29 && this.givenAnswers[1].answerID === 38 && this.givenAnswers[2].answerID === 23 && this.givenAnswers[3].answerID === 36 && this.accessKey === false && this.atLevel===1) {
                this.createSmallGameLevel2(this);
            }
        }
        this.HUD.bringToTop();
        this.item1.bringToTop();
    },
    changeSmallScenes: function (e) {
        if (!this.scene.shown && !this.paused) {
            //resets cameraview
            this.event.cameraMan.x = 512;
            //shows the small scenes
            this.scene.width = 1024;
            this.scene.height = 768;
            this.scene.id = e.id;
            this.scene.frame = e.id - 1;
            this.scene.shown = true;
            if (e.id === 2) {
                this.event.showHideColors(this.event.showColour, true);
            }
            if (e.id === 3) {
                this.event.theTask.visible = true;
            }
            //adds back Btnton
            var backBtn = this.event.add.button(10, 630, "backBtn", this.event.backBtnHandler, {
                event: this.event,
                scene: this.scene
            }, 0, 0, 1);
        }
    },
    handleSmallScenes: function (e) {
        if (e.id === 22 && !this.event.paused) {
            this.event.paused = true;
            this.event.createSmallGame(this.event);
        }

        if (e.id === 6 && this.event.smallScene.id === 5 && !this.event.paused && this.event.accessKey) {
            this.event.smallScene.id = 6;
            this.event.smallScene.frame = 5;
            if (!this.event.keyTaken) {
                this.event.key.visible = true;
                this.event.key.bringToTop();
            }
        }

        if (e.id === 9 && !this.event.paused) {
            this.event.theTaskText.visible = true;
        }
    },
    backBtnHandler: function (e) {
        if (!this.event.paused) {
            if (this.scene.id === 2) {
                this.event.showHideColors(this.event.showColour, false);
            }
            if (this.scene.id === 4) {
                this.event.iPad.visible = false;
            }
            if (this.scene.id === 3) {
                this.event.theTask.visible = false;
            }
            if (this.scene.id === 6 && !this.event.keyTaken) {
                this.event.key.visible = false;
            }
            this.event.theTaskText.visible = false;
            this.scene.width = 0;
            this.scene.height = 0;
            this.scene.id = -1;
            this.scene.shown = false;
        }
        else {
            this.event.destroySmallGame(this.event);
            this.event.answerToGame.visible = false;
        }
        e.kill();
        e = null;
    },
    showHideColors: function (colors, com) {
        for (var i = 0; i < colors.length; i++) {
            colors[i].visible = com;
        }
    },
    createSmallGame: function (game) {
        console.log(game);
        game.smallBackGround = addActor(game, 0, 0, "backgroundSmallGame", 1024, 768, 20, false, {}, {});
        game.answers = [];
        game.givenAnswers = [];
        game.atLevel = 1;
        var startX = 216;
        var startY = 303;
        for (var i = 0; i < 20; i++) {
            if (i < 4) {
                game.givenAnswers.push(addActor(game, startX, 128, "empty", 100, 50, 21 + i, false, {}, {}));
                game.givenAnswers[i].answerID = 0;
            }
            game.answers.push(addActor(game, startX, startY, i + 1, 100, 50, 21 + i, true, function (e) {
                if (!game.accessKey) {
                    game.givenAnswers[(e.id - 21) % 4].loadTexture(e.id - 20);
                    game.givenAnswers[(e.id - 21) % 4].answerID = e.id;
                }
            }, game));
            startX += 164;
            if ((i + 1) % 4 === 0) {
                startX = 216;
                startY += 65;
            }
            if (game.accessKey === true){
                game.answerToGame.bringToTop();
                game.answerToGame.visible = true;
            }
        }
        //adds back Btnton
        this.backBtn = game.add.button(10, 630, "backBtn", game.backBtnHandler, {
            event: game,
            scene: game.smallScene
        }, 0, 0, 1);
    },
    createSmallGameLevel2: function (game) {
        game.smallBackGround.bringToTop();
        game.backBtn.bringToTop();
        game.smallBackGround.loadTexture("backgroundSmallGameLevel2");
        game.atLevel = 2;
        //enter Btn
        game.entBtn = addActor(game, 447, 621, "enterBtn", 128, 64, 30, true, function () {
            console.log(this.num1.frame + " " + this.num2.frame);
            if (this.num2.frame === 1 && this.num1.frame === 6 && !this.accessKey) {
                this.accessKey = true;
                this.answerToGame.visible = true;
                this.answerToGame.bringToTop();
            }
        }, game);
        //2 numbers
        game.num1 = addActor(game, 510, 540, "numbers", 64, 64, 31, true, game.increaseNumber, {});
        game.num2 = addActor(game, 452, 540, "numbers", 64, 64, 32, true, game.increaseNumber, {});

    },
    destroySmallGame: function (game) {
        game.smallBackGround.destroy();
        for (var i = 0; i < 20; i++) {
            if (i < 4) {
                game.givenAnswers[i].kill();
            }
            game.answers[i].kill();
        }
        if (game.atLevel === 2) {
            game.entBtn.destroy();
            game.num1.destroy();
            game.num2.destroy();
        }
        game.atLevel === 0;
        game.paused = false;

    },
    increaseNumber: function (e) {
        if (e.frame === 9)
            e.frame = 0;
        else e.frame++;
    }

}

//opravi klaviaturata na mikrovylnovata
var level4 = function (game) { };
level4.prototype = {
    cameraMove: false,
    paused: false,
    mouseX: 0,
    oldMouseX: 0,
    itemSelected: null,
    boltcheta: true,
    chekmedjeOpened: false,
    doorLocked: true,
    microwaveOpened: false,
    chiniqIzchistena: false,
    colours: [0x162D16, 0xBF101C, 0xB2610B, 0xffffff],

    preload: function () {
        //loading screen
        this.loadBck = this.add.sprite(0, 0, "loadingBackground");
        this.loadingHearts = [];
        this.atLoading = 1;
        for (var i = 0; i < 6; i++) {
            this.loadingHearts.push(this.add.sprite(133 + (i * 128), 439, "loading"));
            this.loadingHearts[i].visible = false;
        }
        game.load.onFileComplete.add(fileComplete, this);
        game.load.onLoadComplete.add(loadComplete, this);
        //secondary
        this.load.image("background", "assets/Level_4/backGround.png");
        this.load.spritesheet("smallscenes", "assets/Level_4/smallscenes.png", 1024, 768);
        this.load.spritesheet("smallscenes2", "assets/Level_4/smallscenes2.png", 1024, 768);
        this.load.spritesheet("smallscenes3", "assets/Level_4/smallscenes3.png", 1024, 768);

        //small takable items
        this.load.image("tikso", "assets/Level_4/takeItems/tikso.png");
        this.load.image("brashno", "assets/Level_4/takeItems/brashno.png");
        this.load.image("qica", "assets/Level_4/takeItems/qica.png");
        this.load.image("kabeli", "assets/Level_4/takeItems/kabeli.png");
        this.load.image("kabeli_zalepeni", "assets/Level_4/takeItems/kabeli_zalepeni.png");
        this.load.image("klyu4", "assets/Level_4/takeItems/klyu4.png");
        this.load.image("otvertka", "assets/Level_4/takeItems/otvertka.png");
        this.load.image("gyba", "assets/Level_4/takeItems/gyba.png");
        //hudItems
        this.load.image("101", "assets/Level_4/HUDItems/101.png");
        this.load.image("102", "assets/Level_4/HUDItems/102.png");
        this.load.image("103", "assets/Level_4/HUDItems/103.png");
        this.load.image("104", "assets/Level_4/HUDItems/104.png");
        this.load.image("105", "assets/Level_4/HUDItems/105.png");
        this.load.image("106", "assets/Level_4/HUDItems/106.png");
        this.load.image("107", "assets/Level_4/HUDItems/107.png");
        this.load.image("108", "assets/Level_4/HUDItems/108.png");
        this.load.image("109", "assets/Level_4/HUDItems/109.png");
        this.load.image("110", "assets/Level_4/HUDItems/110.png");

    },
    create: function () {
        levelNumber = 3;
        //reseting all info
        this.cameraMove = false;
        this.paused = false;
        this.mouseX = 0;
        this.oldMouseX = 0;
        this.itemSelected = null;
        this.boltcheta = true;
        this.chekmedjeOpened = false;
        this.doorLocked = true;
        this.microwaveOpened = false;
        this.chiniqIzchistena = false;
        setUpALevel(this);
        makeHUDItems(this);
        //add items
        //microwaveText
        //adds the text for the safe
        this.micText = this.add.text(420, 80, "", { font: "48px Arial", fill: "#ffffff", align: "center" });
        this.micText.visible = false;
        //album
        this.album = addActor(this, 582, 445, "camera", 140, 50, 1, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: null,
            visibilityHandlerHide: null
        });
        //kniga
        this.kniga = addActor(this, 787, 438, "camera", 101, 42, 3, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: null,
            visibilityHandlerHide: null
        });
        //hladilnik
        this.hladilnik = addActor(this, 74, 87, "camera", 180, 362, 2, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (!game.brashno.taken)
                    game.brashno.visible = true;
                if (!game.qica.taken)
                    game.qica.visible = true;
            },
            visibilityHandlerHide: function (game) {
                game.brashno.visible = false;
                game.qica.visible = false;
            }
        });
        //microwave
        this.microwave = addActor(this, 997, 330, "camera", 142, 82, 4, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.micKeyboard.visible = true;
            },
            visibilityHandlerHide: function (game) {
                game.micKeyboard.visible = false;
            }
        });
        //furna
        this.furna = addActor(this, 598, 397, "camera", 186, 42, 8, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.showHideColors(game.showColour, true);
            },
            visibilityHandlerHide: function (game) {
                game.showHideColors(game.showColour, false);
            }
        });
        //chekmedje
        this.chekmedje = addActor(this, 1145, 440, "camera", 130, 60, 10, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.furnaAndChekmedje.visible = true;
            },
            visibilityHandlerHide: function (game) {
                game.furnaAndChekmedje.visible = false;
            }
        });
        //shahta
        this.shahta = addActor(this, 465, 295, "camera", 75, 72, 12, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.shahtaOtvarqne.visible = true;
            },
            visibilityHandlerHide: function (game) {
                game.shahtaOtvarqne.visible = false;
            }
        });
        //door
        this.door = addActor(this, 1352, 301, "camera", 96, 160, 15, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: null,
            visibilityHandlerHide: null
        });
        //mifka
        this.mifka = addActor(this, 320, 358, "camera", 87, 53, 17, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.kupichka.visible = true;
            },
            visibilityHandlerHide: function (game) {
                game.kupichka.visible = false;
            }
        });
        //podmifka
        this.podmifka = addActor(this, 371, 459, "camera", 71, 83, 18, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (!game.gyba.taken)
                    game.gyba.visible = true;
            },
            visibilityHandlerHide: function (game) {
                game.gyba.visible = false;
            }
        });
        //shkafFormi
        this.shkafFormi = addActor(this, 1135, 116, "camera", 116, 106, 19, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (!game.formaKlyuch.taken)
                    game.formaKlyuch.visible = true;
            },
            visibilityHandlerHide: function (game) {
                game.formaKlyuch.visible = false;
            }
        });
        //shahtaZaOtvarqne
        this.shahtaOtvarqne = addActor(this, 167, 56, "camera", 700, 673, 13, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //snimka
        this.snimka = addActor(this, 562, 342, "camera", 50, 66, 20, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: null,
            visibilityHandlerHide: null
        });
        this.shahtaOtvarqne.visible = false;
        //microwaveKeyboard
        this.micKeyboard = addActor(this, 820, 265, "camera", 118, 199, 5, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        this.micKeyboard.visible = false;
        //furnaAndChekmedje
        this.furnaAndChekmedje = addActor(this, 300, 224, "camera", 456, 329, 201, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        this.furnaAndChekmedje.visible = false;
        //kupi4ka na mifka
        this.kupichka = addActor(this, 675, 488, "camera", 101, 90, 202, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        this.kupichka.visible = false;
        this.furnaAndChekmedje.visible = false;
        //chiniq v mikrovylnova
        this.chiniq = addActor(this, 314, 413, "camera", 325, 96, 207, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        this.chiniq.visible = false;

        //adds take- able items
        //tikso
        this.tikso = addTakableItem(addActor(this, 930, 361, "tikso", 64, 48, 101, true, takeItem, { game: this }), true);
        //brashno
        this.brashno = addTakableItem(addActor(this, 419, 209, "brashno", 120, 120, 102, true, takeItem, { game: this }), false);
        //qice
        this.qica = addTakableItem(addActor(this, 551, 214, "qica", 120, 120, 103, true, takeItem, { game: this }), false);
        //kabeli
        this.kabeli = addTakableItem(addActor(this, 453, 236, "kabeli", 110, 270, 200, true, function (e) {
            if (this.game.itemSelected !== null && this.game.itemSelected.id === 101 && !e.taken) {
                e.taken = true;
                e.loadTexture("kabeli_zalepeni");
                this.game.doorLocked = false;
                removeItemFromHUD(this.game);
            }
        }, { game: this }), false);
        //formaKlyuch
        this.formaKlyuch = addTakableItem(addActor(this, 609, 293, "klyu4", 128, 128, 105, true, takeItem, { game: this }), false);
        //otvertka
        this.otvertka = addTakableItem(addActor(this, 237, 284, "otvertka", 512, 128, 104, true, takeItem, { game: this }), false);
        //gyba
        this.gyba = addTakableItem(addActor(this, 384, 484, "gyba", 200, 100, 109, true, takeItem, { game: this }), false);

        //adding colorsForFurna
        this.showColour = [];
        this.showColour.push(addActor(this, 199, 285, "tester", 42, 86, 203, true, function (e) {
            e.col = ((e.col + 1) % 3) + 1;
            e.tint = this.colours[e.col];
        }, this));
        this.showColour.push(addActor(this, 393, 287, "tester", 42, 86, 204, true, function (e) {
            e.col = ((e.col + 1) % 3) + 1;
            e.tint = this.colours[e.col];
        }, this));
        this.showColour.push(addActor(this, 587, 287, "tester", 42, 86, 205, true, function (e) {
            e.col = ((e.col + 1) % 3) + 1;
            e.tint = this.colours[e.col];
        }, this));
        this.showColour.push(addActor(this, 785, 287, "tester", 42, 86, 206, true, function (e) {
            e.col = ((e.col + 1) % 3) + 1;
            e.tint = this.colours[e.col];
        }, this));
        for (var i = 0; i < this.showColour.length; i++) {
            this.showColour[i].col = 0;
            this.showColour[i].visible = false;
            //changes the colour s 16- no 4islo
            this.showColour[i].tint = this.colours[this.showColour[i].col];
        }
    },
    update: function () {
        if (this.cameraMove && !this.smallScene.shown) {
            this.mouseX = this.input.x;
            this.cameraMan.x = this.cameraMan.x - (this.mouseX - this.oldMouseX);
            if (this.cameraMan.x > 1024)
                this.cameraMan.x = 1024;
            if (this.cameraMan.x < 512)
                this.cameraMan.x = 512;
            this.oldMouseX = this.mouseX;
        }
        if (this.smallScene.id === 8 && this.showColour[0].col === 1 && this.showColour[1].col === 3 && this.showColour[2].col === 3 && this.showColour[3].col === 1) {
            this.smallScene.id = 9;
            this.smallScene.loadTexture("smallscenes2");
            this.smallScene.frame = 0;
            this.furnaAndChekmedje.visible = true;
            this.showHideColors(this.showColour, false);
        }
        this.HUD.bringToTop();
        for (var i = 0; i < 4; i++)
            this.hudItems[i].bringToTop();
        this.selector.bringToTop();
    },
    changeSmallScenes: function (e) {
        if (!this.scene.shown && !this.paused) {
            //resets cameraview
            this.event.cameraMan.x = 512;
            //shows the small scenes
            this.scene.width = 1024;
            this.scene.height = 768;
            this.scene.id = e.id;
            //ako e otvoreno
            if (e.id === 15 && !this.event.doorLocked) {
                openedLevels = 5;
                saveData(5, likedFB);
                this.event.game.state.start("Level5");
            }
                //ako sa razvinteni bolt4etata
            else if (e.id === 12 && !this.event.boltcheta) {
                this.scene.id = 13;
                this.scene.loadTexture("smallscenes2");
                this.scene.frame = 4;
                this.event.kabeli.visible = true;
                this.visibilityHandlerShow = null;
                this.visibilityHandlerHide = function (game) {
                    game.kabeli.visible = false;
                };
            }
                //ako e otvoreno ve4e 4ekmedjeto
            else if (e.id === 10 && this.event.chekmedjeOpened) {
                this.scene.id = 11;
                this.scene.loadTexture("smallscenes2");
                this.scene.frame = 2;
                this.visibilityHandlerShow = null;
                if (!this.event.otvertka.taken)
                    this.event.otvertka.visible = true;
                this.visibilityHandlerHide = null;
            }
                //ako mikrovylnovata e bila otvarqna
            else if (e.id === 4 && this.event.microwaveOpened) {
                if (!this.event.chiniqIzchistena) {
                    this.scene.loadTexture("smallscenes");
                    this.scene.id = 7;
                    this.event.chiniq.visible = true;
                    this.event.chiniq.width = 256;
                    this.event.chiniq.height = 256;
                    this.event.chiniq.x = 420;
                    this.scene.frame = 6;
                }
                else {
                    this.scene.loadTexture("smallscenes2");
                    this.scene.id = 14;
                    this.scene.frame = 5;
                }
                this.visibilityHandlerShow = null;
                this.visibilityHandlerHide = null;
            }

            else {
                if (e.id < 9) {
                    this.scene.loadTexture("smallscenes");
                    this.scene.frame = e.id - 1;
                }
                else if (e.id >= 9 && e.id < 17) {
                    this.scene.loadTexture("smallscenes2");
                    this.scene.frame = e.id - 9;
                }
                else if (e.id >= 17 && e.id < 21) {
                    this.scene.loadTexture("smallscenes3");
                    this.scene.frame = e.id - 17;
                }
            }
            this.scene.shown = true;
            if (this.visibilityHandlerShow !== null)
                this.visibilityHandlerShow(this.event);
            //removes tikso
            if (!this.event.tikso.taken)
                this.event.tikso.visible = false;
            //adds back Btnton
            var backBtn = this.event.add.button(10, 630, "backBtn", this.event.backBtnHandler, {
                event: this.event,
                scene: this.scene,
                visibilityHandler: this.visibilityHandlerHide
            }, 0, 0, 1);
        }
    },
    handleSmallScenes: function (e) {
        //shahta premahvane na bolt4eta
        if (this.scene.id === 12 && this.event.itemSelected !== null && e.id === 13 && this.event.itemSelected.id === 104) {
            this.scene.id = 13;
            this.scene.loadTexture("smallscenes2");
            this.scene.frame = 4;
            this.event.kabeli.visible = true;
            this.event.shahtaOtvarqne.visible = false;
            this.event.boltcheta = false;
            removeItemFromHUD(this.event);
        }
        //furna pekane
        if (this.scene.id === 9 && this.event.itemSelected !== null && e.id === 201 && this.event.itemSelected.id === 107) {
            this.event.itemSelected.id = 108;
            this.event.itemSelected.loadTexture("108");
            this.event.selector.visible = false;
            this.event.itemSelected = null;
        }
        //chekmedje otvarqne
        if (this.scene.id === 10 && this.event.itemSelected !== null && e.id === 201 && this.event.itemSelected.id === 108) {
            this.scene.id = 11;
            this.scene.loadTexture("smallscenes2");
            this.scene.frame = 2;
            this.event.furnaAndChekmedje.visible = false;
            this.event.chekmedjeOpened = true;
            this.event.otvertka.visible = true;
            removeItemFromHUD(this.event);
        }
        //mokrene na gyba v kupichka
        if (this.scene.id === 17 && this.event.itemSelected !== null && e.id === 202 && this.event.itemSelected.id === 109) {
            this.event.itemSelected.id = 110;
            this.event.itemSelected.loadTexture("110");
            this.event.selector.visible = false;
            this.event.itemSelected = null;
        }
        //otvarqne na keyboard mikrovylnoa
        if (this.scene.id === 4 && e.id === 5) {
            this.scene.id = 5;
            this.scene.loadTexture("smallscenes");
            this.scene.frame = 4;
            this.event.micText.visible = true;
        }
        //iz4istvane na chiniq
        if (this.scene.id === 7 && this.event.itemSelected !== null && e.id === 207 && this.event.itemSelected.id === 110) {
            this.event.chiniqIzchistena = true;
            this.event.chiniq.visible = false;
            this.scene.id = 14;
            this.scene.loadTexture("smallscenes2");
            this.scene.frame = 5;
            removeItemFromHUD(this.event);
        }

        //vzimane na chiniq
        if (this.scene.id === 6 && e.id === 207) {
            this.scene.id = 7;
            this.scene.frame = 6;
            e.height = 256;
            e.width = 256;
            this.event.chiniq.x = 420;
        }

        //pisane na kod na keyboard na microwave
        if (this.scene.id === 5) {
            if (this.event.micText.text.length > 6)
                this.event.micText.setText("");
            else {
                var pressed = findNumber(this.event.game.input.x, this.event.game.input.y);
                if (pressed >= 0 && pressed < 10)
                    this.event.micText.setText(this.event.micText.text + pressed);
                console.log(pressed);
                if (pressed === 12) {
                    if (this.event.micText.text === " 8737") {
                        this.event.microwaveOpened = true;
                        this.scene.id = 6;
                        this.scene.frame = 5;
                        this.event.chiniq.visible = true;
                        this.event.micText.visible = false;
                    }
                    else
                        this.event.micText.setText("");
                }
            }
        }

    },
    backBtnHandler: function (e) {
        this.scene.width = 0;
        this.scene.height = 0;
        if (this.scene.id === 13)
            this.event.kabeli.visible = false;
        if (this.scene.id === 9 || this.scene.id === 10) {
            this.event.furnaAndChekmedje.visible = false;
        }
        if (this.scene.id === 11)
            this.event.otvertka.visible = false;
        if (this.scene.id === 6 || this.scene.id === 7)
            this.event.chiniq.visible = false;
        if (!this.event.tikso.taken) {
            this.event.tikso.visible = true;
            this.event.tikso.bringToTop();
        }
        if (this.visibilityHandler !== null)
            this.visibilityHandler(this.event);
        this.scene.id = -1;
        this.scene.shown = false;
        this.event.micText.visible = false;
        e.kill();
        e = null;
    },
    showHideColors: function (colors, com) {
        for (var i = 0; i < colors.length; i++) {
            colors[i].visible = com;
        }
    }
}

var level5 = function (game) { };
level5.prototype = {
    cameraMove: false,
    paused: false,
    stykloSchupeno: false,
    itemSelected: null,
    kalendarOpened: false,
    mouseX: 0,
    oldMouseX: 0,

    preload: function () {
        //loading screen
        this.loadBck = this.add.sprite(0, 0, "loadingBackground");
        this.loadingHearts = [];
        this.atLoading = 1;
        for (var i = 0; i < 6; i++) {
            this.loadingHearts.push(this.add.sprite(133 + (i * 128), 439, "loading"));
            this.loadingHearts[i].visible = false;
        }
        game.load.onFileComplete.add(fileComplete, this);
        game.load.onLoadComplete.add(loadComplete, this);
        //secondary
        this.load.image("background", "assets/Level_5/background.png");
        this.load.spritesheet("smallscenes", "assets/Level_5/smallscenes.png", 1024, 768);
        this.load.spritesheet("smallscenes2", "assets/Level_5/smallscenes2.png", 1024, 768);
        this.load.spritesheet("vyjeSprite", "assets/Level_5/vyjeSprite.png", 440, 235);
        //itemi v malki sceni
        this.load.image("koronaSchupena", "assets/Level_5/koronaSchupena.png");
        this.load.image("stykloSchupeno", "assets/Level_5/stykloSchupeno.png");
        this.load.spritesheet("meseci", "assets/Level_5/meseci.png", 50, 224);
        this.load.image("dateShower", "assets/Level_5/dateShower.png");
        //takableitems
        this.load.image("marker", "assets/Level_5/takeItems/marker.png");
        this.load.image("chetka", "assets/Level_5/takeItems/chetka.png");
        this.load.image("klyuch", "assets/Level_5/takeItems/klyuch.png");
        this.load.image("vyje", "assets/Level_5/takeItems/vyjeVz.png");
        //HUD Items
        this.load.image("111", "assets/Level_5/HUDItems/111.png");
        this.load.image("112", "assets/Level_5/HUDItems/112.png");
        this.load.image("113", "assets/Level_5/HUDItems/113.png");
        this.load.image("114", "assets/Level_5/HUDItems/114.png");
        this.load.image("115", "assets/Level_5/HUDItems/115.png");
        this.load.image("116", "assets/Level_5/HUDItems/116.png");
        //razlikiMiniGame
        this.load.image("razlikiBackground", "assets/Level_5/miniGame/razlikiBackground.png");
        this.load.spritesheet("razlikiChecker", "assets/Level_5/miniGame/diffSprite.png", 50, 50);



    },
    create: function () {
        levelNumber = 4;
        //resetingShits
        this.cameraMove= false;
        this.paused = false;
        this.stykloSchupeno = false;
        this.itemSelected = null;
        this.kalendarOpened = false;
        this.mouseX = 0;
        this.oldMouseX = 0;
        setUpALevel(this);
        makeHUDItems(this);
        //add Items that change the scenes
        //korona
        this.korona = addActor(this, 1331, 268, "camera", 55, 60, 1, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.koronaVShkaf.visible = true;
            },
            visibilityHandlerHide: function (game) {
                game.koronaVShkaf.visible = false;
            }
        });
        //igra4ka
        this.igra4ka = addActor(this, 1083, 547, "camera", 187, 63, 8, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.igra4ka.id === 8) {
                    game.momcheZaVsi4ko.x = 440;
                    game.momcheZaVsi4ko.y = 45;
                    game.momcheZaVsi4ko.width = 105;
                    game.momcheZaVsi4ko.height = 102;
                    game.momcheZaVsi4ko.visible = true;
                }
                if (game.igra4ka.id === 9 && !game.klu4.taken) {
                    game.klu4.visible = true;
                }
            },
            visibilityHandlerHide: function (game) {
                game.momcheZaVsi4ko.visible = false;
                game.klu4.visible = false;
            }
        });
        //shkaf
        this.shkaf = addActor(this, 959, 277, "camera", 134, 70, 2, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (!game.chetka.taken)
                    game.chetka.visible = true;
            },
            visibilityHandlerHide: function (game) {
                game.chetka.visible = false;
            }
        });
        //kartinite
        this.kartinite = addActor(this, 160, 478, "camera", 210, 142, 3, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.kartinite.id === 3) {
                    game.momcheZaVsi4ko.x = 319;
                    game.momcheZaVsi4ko.y = 446;
                    game.momcheZaVsi4ko.width = 462;
                    game.momcheZaVsi4ko.height = 215;
                    game.momcheZaVsi4ko.visible = true;
                }
            },
            visibilityHandlerHide: function (game) {
                game.momcheZaVsi4ko.visible = false;
            }
        });
        //kalendar
        this.kalendar = addActor(this, 765, 154, "camera", 80, 132, 5, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.kalendar.id === 5) {
                    game.data.visible = true;
                    game.dateShower.visible = true;
                    game.shkafSRazliki.visible = false;
                    game.prozorec.visible = false;
                }
                if (game.kalendar.id === 6 && !game.marker.taken)
                    game.marker.visible = true;
            },
            visibilityHandlerHide: function (game) {
                game.data.visible = false;
                game.dateShower.visible = false;
                game.shkafSRazliki.visible = true;
                game.prozorec.visible = true;
                game.marker.visible = false;
            }
        });
        //shkafSRazliki
        this.shkafSRazliki = addActor(this, 434, 238, "camera", 53, 176, 7, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.shkafSRazliki.id === 7) {
                    game.momcheZaVsi4ko.x = 487;
                    game.momcheZaVsi4ko.y = 285;
                    game.momcheZaVsi4ko.width = 140;
                    game.momcheZaVsi4ko.height = 270;
                    game.momcheZaVsi4ko.visible = true;
                }
            },
            visibilityHandlerHide: function (game) {
                game.momcheZaVsi4ko.visible = false;
            }

        });
        //ka6on
        this.ka6on = addActor(this, 983, 606, "camera", 164, 76, 10, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (!game.vyje.taken)
                    game.vyje.visible = true;
            },
            visibilityHandlerHide: function (game) {
                    game.vyje.visible = false;
            }
        });
        //prozorec
        this.prozorec = addActor(this, 588, 212, "camera", 70, 95, 11, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.prozorec.id === 11) {
                    game.momcheZaVsi4ko.x = 578;
                    game.momcheZaVsi4ko.y = 202;
                    game.momcheZaVsi4ko.width = 140;
                    game.momcheZaVsi4ko.height = 180;
                    game.momcheZaVsi4ko.visible = true;
                }
                if (game.prozorec.id === 12) {
                    game.vyjeNaProzorec.visible = true;
                }
            },
            visibilityHandlerHide: function (game) {
                game.momcheZaVsi4ko.visible = false;
                game.vyjeNaProzorec.visible = false;
            }
        });

        //kartinaLqvo
        this.kartinaLqvo = addActor(this, 18, 99, "camera", 141, 218, 13, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: null,
            visibilityHandlerHide: null
        });
        //kartinaDqsno
        this.kartinaDqsno = addActor(this, 1176, 262, "camera", 81, 133, 14, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: null,
            visibilityHandlerHide: null
        });

        //itemi koito sa v malki sceni
        //koronaVShkaf
        this.koronaVShkaf = addActor(this, 320, 130, "camera", 384, 512, 115, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        this.koronaVShkaf.visible = false;
        this.koronaVShkaf.taken = false;
        //momche za vsi4ko
        this.momcheZaVsi4ko = addActor(this, 1, 1, "camera", 0, 0, 200, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        //kalendar data
        this.data = addActor(this, 600, 98, "meseci", 50, 224, 201, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene
        });
        this.data.angle += 90;
        this.data.visible = false;
        //dateShower
        this.dateShower = addActor(this, 439, 155, "dateShower", 64, 64, 202, false, {}, {});
        this.dateShower.visible = false;
        //vyje na prozorec
        this.vyjeNaProzorec = addActor(this, 391, 539, "vyjeSprite", 440, 235, 203, true, function (e) {
            if (e.frame === 1) {
                console.log("game over");
                this.game.state.start("endScreen");
            }
            if (e.frame === 0 && this.itemSelected !== null && this.itemSelected.id === 113) {
                e.frame = 1;
                removeItemFromHUD(this);
            }
        }, this);
        this.vyjeNaProzorec.visible = false;

        //takableItems
        //marker
        this.marker = addTakableItem(addActor(this, 433, 682, "marker", 125, 30, 112, true, takeItem, { game: this }), false);
        //chuk
        this.chuk = addTakableItem(addActor(this, 0, 0, "camera", 0, 0, 114, false, {}, {}), false);
        //chetka
        this.chetka = addTakableItem(addActor(this, 200, 230, "chetka", 512, 128, 111, true, takeItem, { game: this }), false);
        //vyje
        this.vyje = addTakableItem(addActor(this, 375, 295, "vyje", 267, 273, 113, true, takeItem, { game: this }), false);
        //klyu4
        this.klu4 = addTakableItem(addActor(this, 430, 410, "klyuch", 60, 140, 116, true, takeItem, { game: this }), false);


    },
    update: function () {
        if (!this.paused) {
            if (this.cameraMove && !this.smallScene.shown) {
                this.mouseX = this.input.x;
                this.cameraMan.x = this.cameraMan.x - (this.mouseX - this.oldMouseX);
                if (this.cameraMan.x > 1024)
                    this.cameraMan.x = 1024;
                if (this.cameraMan.x < 512)
                    this.cameraMan.x = 512;
                this.oldMouseX = this.mouseX;
            }
            this.HUD.bringToTop();
            for (var i = 0; i < 4; i++)
                this.hudItems[i].bringToTop();
            this.selector.bringToTop();
        }
    },
    changeSmallScenes: function (e) {
        if (!this.scene.shown && !this.paused) {
            //resets cameraview
            this.event.cameraMan.x = 512;
            //shows the small scenes
            this.scene.width = 1024;
            this.scene.height = 768;
            this.scene.id = e.id;
            if (e.id < 9) {
                this.scene.loadTexture("smallscenes");
                this.scene.frame = e.id - 1;
            }
            else {
                this.scene.loadTexture("smallscenes2");
                this.scene.frame = e.id - 9;
            }
            this.scene.shown = true;
            if (this.visibilityHandlerShow !== null)
                this.visibilityHandlerShow(this.event);
            //adds back Btnton
            var backBtn = this.event.add.button(10, 630, "backBtn", this.event.backBtnHandler, {
                event: this.event,
                scene: this.scene,
                visibilityHandler: this.visibilityHandlerHide
            }, 0, 0, 1);
        }
    },
    handleSmallScenes: function (e) {
        if (!this.event.paused) {
            //vzima koronata
            if (this.scene.id === 1 && e.id === 115 && this.event.stykloSchupeno && !e.taken) {
                takeItemIndirectly(e, this.event);
                this.event.koronaVShkaf.loadTexture("stykloSchupeno");
                e.visible = true;
            }
            //chupi stykloto
            if (this.scene.id === 1 && this.event.itemSelected !== null && e.id === 115 && this.event.itemSelected.id === 114) {
                this.event.koronaVShkaf.destroy();
                this.event.koronaVShkaf = addActor(this.event, 320, 130, "koronaSchupena", 384, 512, 115, true, this.event.handleSmallScenes, {
                    event: this.event,
                    scene: this.event.smallScene
                });
                this.event.stykloSchupeno = true;
                removeItemFromHUD(this.event);
            }
            //slaga koronata
            if (this.scene.id === 8 && this.event.itemSelected !== null && e.id === 200 && this.event.itemSelected.id === 115) {
                this.scene.id = 9;
                this.scene.loadTexture("smallscenes2");
                this.scene.frame = 0;
                this.event.igra4ka.id = 9;
                this.event.klu4.visible = true;
                removeItemFromHUD(this.event);
            }
            //chisti kartini
            if (this.scene.id === 3 && this.event.itemSelected !== null && e.id === 200 && this.event.itemSelected.id === 111) {
                this.scene.id = 4;
                this.scene.loadTexture("smallscenes");
                this.scene.frame = 3;
                this.event.kartinite.id = 4;
                removeItemFromHUD(this.event);
            }
            //opravq datite
            if (this.scene.id === 5 && e.id === 5 && !this.event.kalendarOpened) {
                var x = this.gamePointer.game.input.x;
                var y = this.gamePointer.game.input.y;
                console.log(x + " " + y);
                if (x > 305 && x < 371 && y > 92 && y < 149) {
                    if (this.event.data.frame === 0)
                        this.event.data.frame = 11;
                    else this.event.data.frame--;
                }
                else if (x > 599 && x < 656 && y > 90 && y < 148) {
                    if (this.event.data.frame === 11)
                        this.event.data.frame = 0;
                    else this.event.data.frame++;
                }
                else if (x > 303 && x < 653 && y > 151 && y < 651) {
                    //move date shower
                    this.event.dateShower.x = x - 32;
                    this.event.dateShower.y = y - 32;
                }
                
                if (this.event.dateShower.x > 494 && this.event.dateShower.x < 516 && this.event.dateShower.y > 358 && this.event.dateShower.y < 384 && this.event.data.frame === 1) {
                    this.event.kalendarOpened = true;
                    //do the shit
                    this.scene.id = 6;
                    this.scene.loadTexture("smallscenes");
                    this.scene.frame = 5;
                    this.event.kalendar.id = 6;
                    this.event.data.visible = false;
                    this.event.dateShower.visible = false;
                    this.event.marker.visible = true;
                }
            }
            //vliza v razlikite
            if (this.scene.id === 7 && this.event.itemSelected !== null && e.id === 200 && this.event.itemSelected.id === 112) {
                //pravi igrata
                this.event.paused = true;
                this.event.makeNameriRazliki();
                this.event.itemToDestroy = this.event.itemSelected;

            }
            if (this.scene.id === 11 && this.event.itemSelected !== null && e.id === 200 && this.event.itemSelected.id === 116) {
                //otvarq prozoreca 
                this.scene.id = 12;
                this.scene.loadTexture("smallscenes2");
                this.scene.frame = 3;
                removeItemFromHUD(this.event);
                this.event.prozorec.id = 12;
                //smenq id na scenata na sledvashtiq nomer i se aktivira 4oveka s vyjeto
                this.event.vyjeNaProzorec.visible = true;
                //koito e s 2 frame-a

            }
        }
    },
    backBtnHandler: function (e) {
        this.scene.width = 0;
        this.scene.height = 0;
        if (this.visibilityHandler !== null)
            this.visibilityHandler(this.event);
        this.scene.id = -1;
        this.scene.shown = false;
        e.kill();
        e = null;
    },
    makeNameriRazliki: function () {
        this.backGround = this.add.sprite(0, 0, "razlikiBackground");
        this.backBtn = this.add.button(10, 630, "backBtn", function () {
            this.destroyMiniGame();
        }, this, 0, 0, 1);
        this.found = 0;
        this.diff1 = addActor(this, 401, 705, "razlikiChecker", 50, 50, 301, true, function () {
            if (this.diff1.frame !== 1) {
                this.diff1.frame = 1;
                this.diff1A.frame = 1;
                this.found++;
                if (this.found === 3)
                    this.endGame();
            }

        }, this);
        this.diff1A = addActor(this, 912, 705, "razlikiChecker", 50, 50, 302, true, function () {
            if (this.diff1A.frame !== 1) {
                this.diff1.frame = 1;
                this.diff1A.frame = 1;
                this.found++;
                if (this.found === 3)
                    this.endGame();
            }

        }, this);
        this.diff2 = addActor(this, 271, 134, "razlikiChecker", 50, 50, 303, true, function () {
            if (this.diff2.frame !== 1) {
                this.diff2.frame = 1;
                this.diff2A.frame = 1;
                this.found++;
                if (this.found === 3)
                    this.endGame();
            }

        }, this);
        this.diff2A = addActor(this, 787, 134, "razlikiChecker", 50, 50, 304, true, function () {
            if (this.diff2A.frame !== 1) {
                this.diff2.frame = 1;
                this.diff2A.frame = 1;
                this.found++;
                if (this.found === 3)
                    this.endGame();
            }
        }, this);
        this.diff3 = addActor(this, 334, 410, "razlikiChecker", 75, 75, 305, true, function () {
            if (this.diff3.frame !== 1) {
                this.diff3.frame = 1;
                this.diff3A.frame = 1;
                this.found++;
                if (this.found === 3)
                    this.endGame();
            }
        }, this);
        this.diff3A = addActor(this, 860, 410, "razlikiChecker", 75, 75, 306, true, function () {
            if (this.diff3.frame !== 1) {
                this.diff3.frame = 1;
                this.diff3A.frame = 1;
                this.found++;
                if (this.found === 3)
                    this.endGame();
            }
        }, this);
    },
    destroyMiniGame: function () {
        this.backGround.destroy();
        this.backBtn.kill();
        this.backBtn = null;
        this.diff1.destroy();
        this.diff1A.destroy();
        this.diff2.destroy();
        this.diff2A.destroy();
        this.diff3.destroy();
        this.diff3A.destroy();
        this.paused = false;
    },
    endGame: function () {
        this.destroyMiniGame();
        this.itemSelected = this.itemToDestroy;
        takeItemIndirectly(this.chuk, this);
        removeItemFromHUD(this);
    }
}

var mainMenu = function (game) { };
mainMenu.prototype = {

    preload: function () {
        this.load.image("backgroundMainMenu", "assets/mainMenu/mainMenu_backGround.png");
        this.load.image("popUp", "assets/mainMenu/popUp.png");
        this.load.spritesheet("startBtn", "assets/mainMenu/menuStartBtn.png", 512, 256);
        this.load.spritesheet("rateBtn3", "assets/mainMenu/stnRate.png", 512, 256);
        this.load.spritesheet("lv1Btn", "assets/mainMenu/lv1Btn.png", 128, 128);
        this.load.spritesheet("lv2Btn", "assets/mainMenu/lv2Btn.png", 128, 128);
        this.load.spritesheet("lv3Btn", "assets/mainMenu/lv3Btn.png", 128, 128);
        this.load.spritesheet("lv4Btn", "assets/mainMenu/lv4Btn.png", 128, 128);
        this.load.spritesheet("lv5Btn", "assets/mainMenu/lv5Btn.png", 128, 128);

        //main
        this.load.image("camera", "assets/prazno.png");
        this.load.image("tester", "assets/prazno2.png");
        this.load.image("HUD", "assets/hud2.png");
        this.load.spritesheet("backBtn", "assets/backButtonsForScene.png", 256, 128);
        this.load.spritesheet("backToMenuBtn", "assets/backToMenuButt.png", 100, 100);
        this.load.spritesheet("helpBtn", "assets/helpSprite.png", 100, 100);
        this.load.spritesheet("hintsBtn", "assets/hintsBtn.png", 200, 100);
        this.load.image("unmuted", "assets/unmuted.png");
        this.load.image("muted", "assets/muted.png");
        this.load.spritesheet("itemKey", "assets/Level_1/keys.png", 64, 64);
        this.load.image("selector", "assets/selector.png");
        this.load.image("messbox", "assets/messbox.png");
        this.load.spritesheet("fbBtn", "assets/fbBtn.png", 140, 70);
        this.load.spritesheet("rateBtn2", "assets/rateBtn2.png", 200, 100);
        this.load.spritesheet("rateBtn", "assets/rateBtn.png", 100, 64);

   },
    create: function () {
        //background and start Button
        this.backGroundRoom = this.add.sprite(0, 0, "backgroundMainMenu");
        //adds rate Btn
        this.rateBut = this.add.button(256, 482, "rateBtn3", function () {
            navigator.app.loadUrl(rateLink, { openExternal: true });
        }, this, 0, 0, 1);
        this.startBtn = this.add.button(256, 226, "startBtn", function () {
            this.popUp.visible = true;
            for (var i = 0; i < openedLevels; i++)
                this.levels[i].visible = true;
            //backBtn
            this.bckBut = this.add.button(384, 532, "backBtn", function (e) { 
                this.popUp.visible = false;
                for (var i = 0; i < openedLevels; i++)
                    this.levels[i].visible = false;
                e.destroy();
            }, this, 0, 0, 1);
        }, this, 0, 0, 1);
        //popUp kato se natisne start
        this.popUp = this.add.sprite(256, 192, "popUp");
        this.popUp.inputEnabled = true;
        this.popUp.visible = false;
        this.levels = [];
        var startX = 314; //razlika 137
        var startY = 252;
        for (var i = 0; i < 5; i++) {
            this.levels.push(this.add.button(startX, startY, "lv" + (i + 1) + "Btn", function (e) {
                this.state.start(e.id);
            }, this, 0, 0, 1));
            startX += 137;
            this.levels[i].id = "Level" + (i + 1);
            this.levels[i].opened = false;
            this.levels[i].visible = false;
            if ((i + 1) % 3 === 0) {
                startX = 314;
                startY += 137;
            }
        }
    },
    update: function () {

    }

}