var onDeviceReady = function () {
    document.addEventListener("backbutton", function (e) {
        //clearInterval(timerAdInt);
        function onConfirm(btnPressed){
            if (btnPressed === 2) {
                    navigator.app.exitApp();
                }
        }
        e.preventDefault();
        navigator.notification.confirm(
            "Are you sure you want to exit?", // message
            onConfirm, // callback to invoke with index of button pressed
            "Exit", // title
            ["No", "Yes"] // buttonLabels
            );
    }, false);
    setTimeout(function () {
        navigator.splashscreen.hide();
        //initAdMob();
        initAdColony();
        game = new Phaser.Game(1024, 768, Phaser.AUTO, "game");
        game.state.add("boot", boot);
        game.state.add("mainMenu", mainMenu);
        game.state.add("Level1", level1);
        game.state.add("Level2", level2);
        game.state.add("Level3", level3);
        game.state.add("after3rdLevelScreen", after3rdLevelScreen);
        game.state.add("Level4", level4);
        game.state.add("Level5", level5);
        game.state.add("endScreen", endScreen);
        setTimeout(function () {
           /* timerAdInt = setInterval(function () {
                showAd();
            }, 300000); */
            game.state.start("boot");
        }, 500);
    }, 1000);
};
document.addEventListener("deviceready", onDeviceReady, false);

//Old AdMob API
/*
function initAdMob() {
    if (window.plugins && window.plugins.AdMob) {
        var admob_key_banner = "ca-app-pub-2379902636080980/9091234151";
        var admob_key_interstitial = "ca-app-pub-2379902636080980/9230834959";
        window.plugins.AdMob.setOptions({
            publisherId: admob_key_banner,
            bannerAtTop: false, // set to true, to put banner at top
            overlap: false, // set to true, to allow banner overlap webview
            offsetTopBar: true, // set to true to avoid ios7 status bar overlap                    
            interstitialAdId: admob_key_interstitial,
            autoShow: true, // autoshow intertitial Ad
            isTesting: false // receiving test ad
        });
    } else {
    }
}

function showAdMobBanner() {
    window.plugins.AdMob.createBannerView();
}

function showAdMobInterstitial() {
    window.plugins.AdMob.createInterstitialView();
}

function showAd() {
    showAdMobInterstitial();
}

function levelStartAd() {
    clearInterval(timerAdInt);
    timerAdInt = setInterval(function () {
        showAd();
    }, 90000);
    setTimeout(function () {
        showAd();
    }, 1000);
}
*/
function levelStartAd() {
}
